unit svcExample22;

{
SvCom Example showing how to 
- reuse the service module to create several 
  services in one service application
- make the service application self-starting
- communicate with service using windows messages

More detailes and sources are available at
http://www.aldyn.ru/demos/0022/

(C) 2000 Alexey A. Dynnikov <aldyn@aldyn.ru>
}

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Dialogs,
    Controls,
    IniFiles,
    SvCom_NTService;

const WM_BEEP = WM_USER+1;

type
  TsvcServiceBase = class(TNTService)
    procedure svcServiceBaseStart(Sender: TNtService;
      var DoAction: Boolean);
    procedure svcServiceBaseStop(Sender: TNtService;
      var DoAction: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure WMBeep(var Message: TMessage); message WM_BEEP;
  end;

var
  svcServiceBase: TsvcServiceBase;

implementation

{$R *.DFM}


procedure TsvcServiceBase.svcServiceBaseStart(Sender: TNtService;
  var DoAction: Boolean);
var Ini: TIniFile;
begin
    Ini:=TIniFile.Create(ChangeFileExt(ParamStr(0), '.DAT'));
    Ini.WriteInteger(Name,'ThreadId',GetCurrentThreadId);
    Ini.Free;
end;

procedure TsvcServiceBase.svcServiceBaseStop(Sender: TNtService;
  var DoAction: Boolean);
var Ini: TIniFile;
begin
    Ini:=TIniFile.Create(ChangeFileExt(ParamStr(0), '.DAT'));
    Ini.WriteInteger(Name,'ThreadId',0);
    Ini.Free;
end;

procedure TsvcServiceBase.WMBeep(var Message: TMessage);
begin
    Windows.Beep(Message.WParam,Message.LParam);
end;

end.

